#include <dos.h>
#include <conio.h>
#include "except.h"

        static int m_nPortBase;
        static BOOL m_bUseInt;
        static INTERRUPT m_vector;
    public:
        enum PARITY {NOPARITY, EVENPARITY, ODDPARITY};
	public:
        CCom();
        ~CCom();
        void open(short nport=COM1, long baudrate=9600, short charbits=8,
            short stopbits=1, PARITY parity=NOPARITY, BOOL bUseInt);
        void close();

        void write(char *, int size); // send one char
        void writeChar(char); // send a group of data
        void writeInt(short);
        void writeLong(long);
        void writeString(short,...);

        void read(char *, int size); // send one char
        char readChar(); // send a group of data
        short readInt();
        long readLong();

        void setParityBit();
        void clearParityBit();

        void open
            

CCom::CCom();
CCom::~CCom();
void CCom::open(short nport, long baudrate, short charbits,
    short stopbits, PARITY parity, BOOL bUseInt);
{
    // Init Serial port
    m_nPortBase=getPortBase(nport);

    outp(REG_LCR,0x80);	// setup baudrate
    outp(REG_LSB,getBaudLo(baudrate));
    outp(REG_MSB,getBaudHi(baudrate));
    outp(REG_LCR,0x2b);	// 8, n, 1. setup data format
    outp(REG_MCR,0x03);	// disable OUT2
	outp(REG_IER,0x00);  // disable interrupt
}
void CCom::close()
{
}
void CCom::write(char *p, int size); // send one char
{
    outp(getAddr(REG_LCR),0x3b);

	char state;
	for(int len=0;len<size;)
	{
        state=inp(getAddr(REG_LSR));
		if(state & 0x20)
		{
            outp(getAddr(REG_THR),*(p+len));
			len++;
		}
	}
}
void CCom::writeChar(char); // send a group of data
{
	char state;
	for(;;)
	{
        state=inp(getAddr(REG_LSR));
		if(state & 0x20)
		{
            outp(getAddr(REG_THR),ch);
			break;
		}
	}
}
void CCom::writeInt(short);
void CCom::writeLong(long);
void CCom::writeString(short,...);

void CCom::read(char *, int size); // send one char
char CCom::readChar(); // send a group of data
short CCom::readInt();
long CCom::readLong();

void CCom::setParityBit();
void CCom::clearParityBit();

void CCom::SendData(char ch) // send one char
{
}
void CCom::SendData(char *p, int size) // send a group of data
{
    outp(REG_LCR,0x3b);

	char state;
	for(int len=0;len<size;)
	{
		state=inp(REG_LSR);
		if(state & 0x20)
		{
			outp(REG_THR,*(p+len));
			len++;
		}
	}
}

void CCom::SendCmd(char nUser) // select user
{
    outp(REG_LCR,0x2b);
    //printf("%02x\n", inp(0x2fb));
    char state;
	for(;;)
	{
		state=inp(REG_LSR);
		if(state & 0x20)
		{
			outp(REG_THR,nUser);
			break;
		}
	}
}
void CCom::SendClear(char nUser) 	// clear command
{
    SendCmd(nUser);
	SendData(0x00);
    SendData(0x00);
}
int CCom::Peer()
{
	outp(REG_LCR,0x03);
    return inp(REG_LSR)&0x01;
}

int CCom::ReadData()
{
	outp(REG_LCR,0x03);
    char state;
	for(;;)
	{
		state=inp(REG_LSR);
		if(state & 0x01)
		{
			return inp(REG_RBR);
		}
	}
}
int CCom::ReadData(char *p, int size)
{
	outp(REG_LCR,0x03);
    char state;
	for(int n=0;n<size;)
	{
		state=inp(REG_LSR);
        if(state & 0x1e)
        	n++;
		else if(state & 0x01)
		{
			p[n]=inp(REG_RBR)&0xff;
            n++;
		}
	}
    return n;
}
