#include <graph.h>
#include <string.h>
#include <ctype.h>
#include <dos.h>
#include <conio.h>
#include <stdlib.h>
#include <user.h>

#include "misc.hpp"
#include "control.hpp"
#include "except.hpp"
#include "keybrd.hpp"
#include "chinese.hpp"

CPoint::CPoint()
{
    x=y=0;
}
CPoint::CPoint(int x0, int y0)
{
    x=x0;
    y=y0;
}
CPoint::CPoint(CPoint &pt)
{
    x=pt.x;
    y=pt.y;
}
CPoint::~CPoint()
{
}
void CPoint::setPoint(int x0, int y0)
{
    x=x0;
    y=y0;
}
void CPoint::setPoint(CPoint &pt)
{
    x=pt.x;
    y=pt.y;
}

///////////////////////////// implemetation of CRect ///////////////////
CRect::CRect()
{
    x=y=cx=cy=0;
}
CRect::CRect(int x0, int y0, int cx0, int cy0)
{
    x=x0;
    y=y0;
    cx=cx0;
    cy=cy0;
}
CRect::CRect(CRect &rect)
{
    x=rect.x;
    y=rect.y;
    cx=rect.cx;
    cy=rect.cy;
}
CRect::~CRect()
{
}
void CRect::setRect(int x0, int y0, int cx0, int cy0)
{
    x=x0;
    y=y0;
    cx=cx0;
    cy=cy0;
}
void CRect::setRect(CRect &rect)
{
    x=rect.x;
    y=rect.y;
    cx=rect.cx;
    cy=rect.cy;
}
BOOL CRect::isPtInside(int x0, int y0)
{
    if((x0<x)||(x0>cx))
        return FALSE;
    if((y0<y)||(y0>cy))
        return FALSE;
    return TRUE;
}
BOOL CRect::isPtInside(CPoint &pt)
{
    if((pt.x<x)||(pt.x>cx))
        return FALSE;
    if((pt.y<y)||(pt.y>cy))
        return FALSE;
    return TRUE;
}
//////////////////////// end of implemetation of CRect ///////////////////


///////////////// CButton /////////////////////////////
CButton::CButton(char *ptr, short clr, int x, int y, int sx, int sy, BOOL bEn)
{
    m_bEnable=bEn;
    m_rcBtn.setRect(x, y, sx, sy);
    if(ptr!=NULL)
    {
        m_pText=new char[strlen(ptr)+1];
        if(!m_pText)
            throw XMemoryException();
        strcpy(m_pText, ptr);
    }
    else
        m_pText=NULL;
    m_color=clr;
    paint();
}
CButton::CButton(char *ptr, short clr, CRect &rect, BOOL bEn)
{
    m_bEnable=bEn;
    m_rcBtn.setRect(rect);
    if(ptr!=NULL)
    {
        m_pText=new char[strlen(ptr)+1];
        if(m_pText==NULL) throw XMemoryException();
        strcpy(m_pText, ptr);
    }
    else
        m_pText=NULL;
    m_color=clr;
    paint();
}
CButton::CButton(CButton &btn)
{
    m_bEnable=btn.m_bEnable;
    m_rcBtn.setRect(btn.m_rcBtn);
    if(btn.m_pText!=NULL)
    {
        m_pText=new char[strlen(btn.m_pText)+1];
        if(!m_pText) throw XMemoryException();
        strcpy(m_pText, btn.m_pText);
    }
    else
        m_pText=NULL;
    m_color=btn.m_color;
    paint();
}
CButton::~CButton()
{
    if(m_pText)
        delete m_pText;
}
void CButton::click()
{
    if(m_bEnable)
    {
        int x, y;
        paint(PRESSED);
        beep(10);
        delay(100);
        beep(5);
        paint();
    }
}
void CButton::enable(BOOL bEn)
{
    m_bEnable=bEn;
    paint();
}
void CButton::paint(BUTTONSTATE bs)
{
    int x, y;
    int shift=0;
    CShape shape;
    Chinese chin("FONT.LIB");

    x=(m_rcBtn.cx-m_rcBtn.x-strlen(m_pText)*8)/2;
    y=(m_rcBtn.cy-m_rcBtn.y-16)/2;
    if(bs==RELEASED)
        shape.drawBox(m_rcBtn.x+1, m_rcBtn.y+1, m_rcBtn.cx-1,
            m_rcBtn.cy-1, CShape::CONVEX, TRUE);
    else
        shape.drawBox(m_rcBtn.x+1, m_rcBtn.y+1, m_rcBtn.cx-1,
            m_rcBtn.cy-1, CShape::CONCAVE, TRUE);

    if(bs==PRESSED)
        shift=1;
    if(m_bEnable)
        chin.printString(m_rcBtn.x+x+shift, m_rcBtn.y+y+shift, m_pText, m_color);
    else
    {
        chin.printString(m_rcBtn.x+x+1+shift, m_rcBtn.y+y+1+shift, m_pText, WHITE);
        chin.printString(m_rcBtn.x+x+shift, m_rcBtn.y+y+shift, m_pText, DARKGRAY);
    }
}
void CButton::setFocus(BOOL bSet)
{
    if(bSet)
        _setcolor(BLACK);
    else
        _setcolor(LIGHTGRAY);
    _rectangle(_GBORDER, m_rcBtn.x, m_rcBtn.y, m_rcBtn.cx, m_rcBtn.cy);
}



void CShape::drawBox(int x0, int y0, int x1, int y1, BOXSHAPE shape, BOOL bPaintBk)
{
	short color=_getcolor();
	_setcolor(LIGHTGRAY);
	if(bPaintBk)
		_rectangle(_GFILLINTERIOR,x0,y0,x1,y1);
	if(shape==PLAIN)
	{
		_moveto(x0,y1);
		_lineto(x0,y0);
		_lineto(x1,y0);
		_lineto(x1,y1);
		_lineto(x0,y1);
	}
    else if(shape==CONCAVE)
	{
		_setcolor(DARKGRAY);
		_moveto(x0,y1);
		_lineto(x0,y0);
		_lineto(x1,y0);
		_setcolor(WHITE);
		_lineto(x1,y1);
		_lineto(x0,y1);
	}
	else if(shape==CONVEX)
	{
		_setcolor(WHITE);
		_moveto(x0,y1);
		_lineto(x0,y0);
		_lineto(x1,y0);
		_setcolor(DARKGRAY);
		_lineto(x1,y1);
		_lineto(x0,y1);
	}
	_setcolor(color);
}

//////////// Static /////////////////
CStatic::CStatic(short sx, short sy, char const *stext, short slen,
            CShape::BOXSHAPE sshape, COLORS scolor,
            COLORS sbkcolor)
{
    m_bShow=FALSE;
	x=sx; y=sy;
	len=round(slen,0,80);
	if(len)
	{
		text=new char [len];
        if(!text) throw XMemoryException();
		if(stext)
			strncpy(text,stext,len);
		else
			text[0]=0;
	}
	else
		text=NULL;
	shape=sshape;
	color=scolor;
	bkcolor=sbkcolor;
    show();
}
CStatic::CStatic(CStatic const &stat)
{
    m_bShow=stat.m_bShow;
	x=stat.x;
	y=stat.y;
	len=stat.len;
	shape=stat.shape;
	color=stat.color;
	bkcolor=stat.bkcolor;
	if(len)
	{
		text= new char[len];
        if(!text) throw XMemoryException();
		strcpy(text,stat.text);
	}
	else
		text=NULL;
    show();
}
CStatic::~CStatic()
{
    if(m_bShow)
        hide();
	if(text)
		delete text;
}

void CStatic::show()
{
    Chinese chin("FONT.LIB");
    m_bShow=TRUE;
    clear();
	if(len)
        chin.printString(x+2,y+2,text,color);
}
void CStatic::hide()
{
    m_bShow=FALSE;
	short oldcolor=_getcolor();
	_setcolor(LIGHTGRAY);
	_rectangle(_GFILLINTERIOR,x,y,x+len*8+4,y+20);
	_setcolor(oldcolor);
}
void CStatic::setText(char const *stext,short n)
{
	if(stext)
    {
    	if(n==-1)
			strncpy(text,stext,len);
        else
        	strncpy(text,stext,min(len,n));
    }
	else
		text[0]=0;
    show();
}
void CStatic::setText(int n, int radix)
{
	char tmp[80];
    itoa(n,tmp,radix);
	strncpy(text,tmp,len);
    show();
}
void CStatic::setColor(short scolor, short sbkcolor)
{
	color=scolor;
	bkcolor=sbkcolor;
    show();
}
void CStatic::setShape(CShape::BOXSHAPE bs)
{
	shape=bs;
    show();
}
void CStatic::move(short sx,short sy)
{
	x=sx;
	y=sy;
    hide();
    show();
}
void CStatic::clear()
{
	short oldcolor=_getcolor();
    CShape sh;
	_setcolor(bkcolor);
	_rectangle(_GFILLINTERIOR,x,y,x+len*8+4,y+20);
    sh.drawBox(x,y,x+len*8+4,y+20, shape);
	_setcolor(oldcolor);
}
BOOL CStatic::isBlank()
{
	short n;
	for(n=0;n<strlen(text);n++)
    {
    	if( (text[n]!=KEY_TAB)&&(text[n]!=KEY_RETURN)&&(text[n]!=KEY_SPACE) )
        	break;
    }
    return n==strlen(text)?TRUE:FALSE;

}

/////////// Edit ////////////

CEdit::CEdit(short sx, short sy, char const *stext, short slen,
            CShape::BOXSHAPE sshape, short scolor,
			short sbkcolor)
{
    m_bShow=TRUE;
    m_nX=sx; m_nY=sy;
    m_nLen=round(slen,0,80);
    if(m_nLen)
	{
        m_pText=new char [m_nLen];
        if(!m_pText) throw XMemoryException();
		if(stext)
            strncpy(m_pText,stext,m_nLen);
		else
            m_pText[0]=0;
	}
	else
        m_pText=NULL;
    m_bs=sshape;
    m_nColor=scolor;
    m_nBkcolor=sbkcolor;
    show();
}
CEdit::CEdit(CEdit const &stat)
{
    m_bShow=stat.m_bShow;
    m_nX=stat.m_nX;
    m_nY=stat.m_nY;
    m_nLen=stat.m_nLen;
    m_bs=stat.m_bs;
    m_nColor=stat.m_nColor;
    m_nBkcolor=stat.m_nBkcolor;
    if(m_nLen)
	{
        m_pText= new char[m_nLen];
        if(!m_pText) throw XMemoryException();
        strcpy(m_pText,stat.m_pText);
	}
	else
        m_pText=NULL;
    show();
}
CEdit::~CEdit()
{
    if(m_bShow)
        setVisible(FALSE);
    if(m_pText)
        delete m_pText;
}

void CEdit::show()
{
    Chinese chin("FONT.LIB");
    if(m_bShow)
    {
        clear();
        if(m_nLen)
            chin.printString(m_nX+2,m_nY+2,m_pText,m_nColor);
    }
}
void CEdit::setVisible(BOOL bVis)
{
    COLORS oldcolor;
	if(bVis)
    {
        if(m_bShow)
        	return ; // nothing should change
        else
        {
            m_bShow=TRUE;
            show();
        }
    }
    else
    {
        if(!m_bShow)
        	return ;
        else
        {
            m_bShow=FALSE;
			oldcolor=_getcolor();
			_setcolor(LIGHTGRAY);
            _rectangle(_GFILLINTERIOR,m_nX,m_nY,m_nX+m_nLen*8+4,m_nY+20);
			_setcolor(oldcolor);
        }
    }
}
void CEdit::setText(char const *stext,short n)
{
	if(stext)
    {
    	if(n==-1)
            strncpy(m_pText,stext,m_nLen);
        else
            strncpy(m_pText,stext,min(m_nLen,n));
    }
	else
        m_pText[0]=0;
    show();
}
void CEdit::setText(int n, int radix)
{
	char tmp[80];
    itoa(n,tmp,radix);
    strncpy(m_pText,tmp,m_nLen);
    show();
}

BOOL CEdit::usrIsChin(short key)
{
    if(key<0)
		return TRUE;
	return FALSE;
}
BOOL CEdit::usrIsPrint(short key)
{
	if(key&0xff00)
    	return FALSE;
    if(isprint(key))
    	return TRUE;
    return FALSE;
}
void CEdit::clearChar(short x, short y, COLORS color)
{
    COLORS oldcolor=_getcolor();
	_setcolor(color);
	_rectangle(_GFILLINTERIOR,x,y,x+8,y+16);
	_setcolor(oldcolor);
}
short CEdit::getText(char *stext)
{
	if(stext)
        strcpy(stext,m_pText);
    return strlen(m_pText);
}
short CEdit::input(char *stext)
{
    short nPos=strlen(m_pText), key;
    Chinese chin("FONT.LIB");
    char *tmptext=new char [m_nLen+1];
    if(!tmptext) throw XMemoryException();
    strcpy(tmptext,m_pText);
    chin.printString(m_nX+2+nPos*8,m_nY+2,"_",WHITE);
    CKeybrd keybrd;

	for(;;)
	{
        key=keybrd.getKey();
        if(usrIsPrint(key))
		{
            if(nPos+1>m_nLen-1)
                beep();
			else
			{
				tmptext[nPos]=key;
				tmptext[nPos+1]=0;
                clearChar(m_nX+2+nPos*8,m_nY+2,m_nBkcolor);
                chin.printString(m_nX+2+nPos*8,m_nY+2,tmptext+nPos,m_nColor);
				nPos++;
                chin.printString(m_nX+2+nPos*8,m_nY+2,"_",WHITE);
			}
		}
        if(usrIsChin(key))
		{
            if(nPos+2>m_nLen-1)
                beep();
			else
			{
				tmptext[nPos]=(ushort(key)>>8)&0xff;
				tmptext[nPos+1]=ushort(key)&0xff;
				tmptext[nPos+2]=0;
                clearChar(m_nX+2+nPos*8,m_nY+2,m_nBkcolor);
                clearChar(m_nX+2+(nPos+1)*8,m_nY+2,m_nBkcolor);
                chin.printString(m_nX+2+nPos*8,m_nY+2,tmptext+nPos,m_nColor);
				nPos+=2;
                chin.printString(m_nX+2+nPos*8,m_nY+2,"_",WHITE);
			}
		}
		switch(key)
		{
			case KEY_DELETE:
			case KEY_BACKSPACE:
				if(nPos-1>=0)
				{
                    clearChar(m_nX+2+nPos*8,m_nY+2,m_nBkcolor);
					nPos--;
                    clearChar(m_nX+2+nPos*8,m_nY+2,m_nBkcolor);
                    chin.printString(m_nX+2+nPos*8,m_nY+2,"_",WHITE);
					tmptext[nPos]=0;
				}
				else
                    beep();
				break;
			case KEY_RETURN:	// return
                clearChar(m_nX+2+nPos*8,m_nY+2,m_nBkcolor);
                strcpy(m_pText,tmptext);
				strcpy(stext,tmptext);
                show();
				delete tmptext;
				return key;
			case KEY_ESC:
                strcpy(stext,m_pText);
                show();
				delete tmptext;
				return key;
		}
	}
}

void CEdit::setColor(short scolor, short sbkcolor)
{
    Chinese chin("FONT.LIB");
    m_nColor=scolor;
    if(sbkcolor!=-1)
        m_nBkcolor=sbkcolor;
    if(sbkcolor==-1)
    {
        if(m_nLen)
            chin.printString(m_nX+2,m_nY+2,m_pText,m_nColor);
    }
    else
        show();
}
void CEdit::setBkColor(short sbkcolor)
{
    m_nBkcolor=sbkcolor;
    show();
}
void CEdit::move(short sx,short sy)
{
    setVisible(FALSE);
    m_nX=sx;
    m_nY=sy;
    show();
}
void CEdit::clear()
{
    COLORS oldcolor=_getcolor();
    CShape shape;
    _setcolor(m_nBkcolor);
    _rectangle(_GFILLINTERIOR,m_nX,m_nY,m_nX+m_nLen*8+4,m_nY+20);
    shape.drawBox(m_nX,m_nY,m_nX+m_nLen*8+4,m_nY+20,m_bs);
	_setcolor(oldcolor);
}
BOOL CEdit::isBlank()
{
	short n;
    for(n=0;n<strlen(m_pText);n++)
    {
        if( (m_pText[n]!=KEY_TAB)&&(m_pText[n]!=KEY_RETURN)&&
            (m_pText[n]!=KEY_SPACE) )
        	break;
    }
    return n==strlen(m_pText)?TRUE:FALSE;
}


void CShape::drawGroup(int x0, int y0, int x1, int y1, BOXSHAPE shape)
{
	if(shape==CONVEX)
	{
        drawBox(x0,y0,x1,y1,CONVEX);
        drawBox(x0+1,y0+1,x1-1,y1-1,CONCAVE);
	}
	else if(shape==CONCAVE)
	{
        drawBox(x0,y0,x1,y1,CONCAVE);
        drawBox(x0+1,y0+1,x1-1,y1-1,CONVEX);
	}
}
void CShape::drawBump(int x, int y, int len, int bs)
{
    if(bs & VERTICAL)
    {
        if(bs&CONCAVE)
        {
            _setcolor(WHITE);
            _moveto(x, y);
            _lineto(x, y+len);
            _setcolor(DARKGRAY);
            _moveto(x+1, y);
            _lineto(x+1, y+len);
        }
        else
        {
            _setcolor(DARKGRAY);
            _moveto(x, y);
            _lineto(x, y+len);
            _setcolor(WHITE);
            _moveto(x+1, y);
            _lineto(x+1, y+len);
        }
    }
    else
    {
        if(bs&CONCAVE)
        {
            _setcolor(DARKGRAY);
            _moveto(x, y);
            _lineto(x+len, y);
            _setcolor(WHITE);
            _moveto(x, y+1);
            _lineto(x+len, y+1);
        }
        else
        {
            _setcolor(WHITE);
            _moveto(x, y);
            _lineto(x+len, y);
            _setcolor(DARKGRAY);
            _moveto(x, y+1);
            _lineto(x+len, y+1);
        }
    }
}
