#if !defined(CFILE_HPP_)
#define CFILE_HPP_

#include <stdio.h>
#include <user.h>

#include "except.hpp"

class CFile
{
    private:
        FILE *m_hFile;
    public:
        CFile();
        ~CFile();

        void close();
        void flush();
        long getLength();
        BOOL isExist(char *);
        void open(char *, char *md=NULL);
        void read(void *ptr, size_t size);
        int readChar();
        int readInt();
        long readLong();
        void readString(char *, short size);
        void seek(long offset, int pos=SEEK_SET);
        void setPos(fpos_t *poffset);
        long tell();
        void tmpfile();
        void write(void *ptr, size_t size);
        void writeChar(int);
        void writeInt(int);
        void writeLong(long);
        void writeString(char *);

        FILE *getFile() const {return m_hFile;}
} ;

#endif
