#include <graph.h>
#include <stdlib.h>
#include <mem.h>
#include <stdio.h>
#include <conio.h>
#include <bios.h>
#include <dos.h>
#include <string.h>
#include <ctype.h>
#include <user.h>

#include "gymcls.hpp"
#include "gym.pro"
#include "gymdef.h"
#include "token.hpp"

short round(short val,short vmin,short vmax)
{
	short ret;
	ret=val>=vmin?val:vmin;
	ret=ret<=vmax?ret:vmax;
	return ret;
} ;

short min(short a, short b)
{
    return a>b?b:a;
}

void Beep(int nVal)
{
	outp(0x61, inp(0x61)|0x03);
    delay(nVal);
    outp(0x61, inp(0x61)&0xfc);
}
long Code2Off(ushort code)
{
	long q,w;

	q=((code>>8)&0xff)-0xa1;
	w=(code&0xff)-0xa1;

	return (q*94L+w)<<5;
}

long Code2Index(ushort code)
{
	long q,w;

	q=((code>>8)&0xff)-0xa1;
	w=(code&0xff)-0xa1;

    return (q*94L+w);
}
void WriteDebug(char *szFilename, void *ptr, long size, BOOL bAppend)
{
    CFile file;
    try
    {
        if(bAppend)
            file.open(szFilename, "ab");
        else
            file.open(szFilename, "wb");
        file.write(ptr, size);
        file.close();
    }
    catch(XFileIOException e)
    {
    }
}
void DrawBox(short x0,short y0,short x1,short y1,BOXSHAPE shape, BOOL bPaintBk)
{
	short color=_getcolor();
	_setcolor(LIGHTGRAY);
	if(bPaintBk)
		_rectangle(_GFILLINTERIOR,x0,y0,x1,y1);
	if(shape==PLAIN)
	{
		_moveto(x0,y1);
		_lineto(x0,y0);
		_lineto(x1,y0);
		_lineto(x1,y1);
		_lineto(x0,y1);
	}
	else if(shape==CONCAVE)
	{
		_setcolor(DARKGRAY);
		_moveto(x0,y1);
		_lineto(x0,y0);
		_lineto(x1,y0);
		_setcolor(WHITE);
		_lineto(x1,y1);
		_lineto(x0,y1);
	}
	else if(shape==CONVEX)
	{
		_setcolor(WHITE);
		_moveto(x0,y1);
		_lineto(x0,y0);
		_lineto(x1,y0);
		_setcolor(DARKGRAY);
		_lineto(x1,y1);
		_lineto(x0,y1);
	}
	_setcolor(color);
}

void PrintEChar(short x,short y,short nIndex,short color)
{
	short xx,yy,oldcolor;
    CFile file;
	long len;
	byte pDot[16];

    file.open(szChineseLib);
    len=file.getLength();
	len-=4096;
	len+=nIndex*16;
    file.seek(len);
    file.read(pDot, 16);
	
	oldcolor=_getcolor();
	_setcolor(color);

	for(yy=0;yy<16;yy++)
		for(xx=0;xx<8;xx++)
			if((pDot[yy]&mask[xx])!=0)
				_setpixel(x+xx,y+yy+2);
	_setcolor(oldcolor);
    file.close();
}
void PrintCChar(short x,short y,short nIndex,short color)
{
	short xx,yy,ccc,oldcolor;
    CFile file;
	long len;
	byte pDot[32];

    file.open(szChineseLib);
    len=file.getLength();
	len=nIndex*32;
    file.seek(len);
    file.read(pDot, 32);

	oldcolor=_getcolor();
	_setcolor(color);

	for(yy=0;yy<16;yy++)
		for(xx=0;xx<2;xx++)
			for(ccc=0;ccc<8;ccc++)
				if((pDot[(yy<<1)+xx]&mask[ccc])!=0)
					_setpixel(x+(xx<<3)+ccc,y+yy);
	_setcolor(oldcolor);
    file.close();
}
void PrintChar(short x,short y,const char *chin,COLORS color)
{
    CFont font;
    long index;

    if(!font.loadFont(szChineseLib))
        return ;
    font.setDim(16, 16);
    index=Code2Index(((chin[0]<<8)&0xff00)+(chin[1]&0xff));
    font.writeAt(x, y, index, color, TRUE);
}
/* void PrintChar(short x,short y,char const *chin,short color)
{
	short xx,yy,ccc,oldcolor;
    CFile file;
	long len;
	byte pDot[32];

    file.open(szChineseLib);
    len=Code2Off((chin[0]<<8)&0xff00+(chin[1]&0xff));
    file.seek(len);
    file.read(pDot, 32);

	oldcolor=_getcolor();
	_setcolor(color);

	for(yy=0;yy<16;yy++)
		for(xx=0;xx<2;xx++)
			for(ccc=0;ccc<8;ccc++)
				if((pDot[(yy<<1)+xx]&mask[ccc])!=0)
					_setpixel(x+(xx<<3)+ccc,y+yy);
	_setcolor(oldcolor);
    file.close();
}  */
void PrintString(short x,short y,char const *chin,short color)
{
	short xx,yy,ccc,code, n,oldcolor;
    CFile file;
	long len;
	byte pDot[32];

    file.open(szChineseLib);

	oldcolor=_getcolor();

	_setcolor(color);
	for(n=0;chin[n]!=0/*n<nCount*/;)
	{
		if((byte)(chin[n]) > 0xa0)
		{
			code=((chin[n]<<8)&0xff00)+(chin[n+1]&0xff);
			len=Code2Off(code);
            file.seek(len);
            file.read(pDot, 32);
			for(yy=0;yy<16;yy++)
				for(xx=0;xx<2;xx++)
					for(ccc=0;ccc<8;ccc++)
						if((pDot[(yy<<1)+xx]&mask[ccc])!=0)
							_setpixel(x+(xx<<3)+ccc,y+yy);
			x+=16;
			n+=2;
		}
		else
		{
            len=file.getLength();
            len-=4096;
            len+=chin[n]*16;
            file.seek(len);
            file.read(pDot, 16);
	
            for(yy=0;yy<16;yy++)
                for(xx=0;xx<8;xx++)
                    if((pDot[yy]&mask[xx])!=0)
                        _setpixel(x+xx,y+yy+2);
			x+=8;
			n++;
		}
	}
	_setcolor(oldcolor);
    file.close();
}
void PrintConString(short x,short y,char const *ptr,short color)
{
	PrintString(x+2,y+2,ptr,DARKGRAY);
	PrintString(x,y,ptr,color);
}



CPoint::CPoint()
{
    x=y=0;
}
CPoint::CPoint(int x0, int y0)
{
    x=x0;
    y=y0;
}
CPoint::CPoint(CPoint &pt)
{
    x=pt.x;
    y=pt.y;
}
CPoint::~CPoint()
{
}
void CPoint::setPoint(int x0, int y0)
{
    x=x0;
    y=y0;
}
void CPoint::setPoint(CPoint &pt)
{
    x=pt.x;
    y=pt.y;
}

///////////////////////////// implemetation of CRect ///////////////////
CRect::CRect()
{
    x=y=cx=cy=0;
}
CRect::CRect(int x0, int y0, int cx0, int cy0)
{
    x=x0;
    y=y0;
    cx=cx0;
    cy=cy0;
}
CRect::CRect(CRect &rect)
{
    x=rect.x;
    y=rect.y;
    cx=rect.cx;
    cy=rect.cy;
}
CRect::~CRect()
{
}
void CRect::setRect(int x0, int y0, int cx0, int cy0)
{
    x=x0;
    y=y0;
    cx=cx0;
    cy=cy0;
}
void CRect::setRect(CRect &rect)
{
    x=rect.x;
    y=rect.y;
    cx=rect.cx;
    cy=rect.cy;
}
BOOL CRect::isPtInside(int x0, int y0)
{
    if((x0<x)||(x0>cx))
        return FALSE;
    if((y0<y)||(y0>cy))
        return FALSE;
    return TRUE;
}
BOOL CRect::isPtInside(CPoint &pt)
{
    if((pt.x<x)||(pt.x>cx))
        return FALSE;
    if((pt.y<y)||(pt.y>cy))
        return FALSE;
    return TRUE;
}
//////////////////////// end of implemetation of CRect ///////////////////


///////////////// CButton /////////////////////////////
CButton::CButton(char *ptr, short clr, int x, int y, int sx, int sy, BOOL bEn)
{
    m_bEnable=bEn;
    m_rcBtn.setRect(x, y, sx, sy);
    if(ptr!=NULL)
    {
        m_pText=new char[strlen(ptr)+1];
        if(!m_pText)
            throw XMemoryException();
        strcpy(m_pText, ptr);
    }
    else
        m_pText=NULL;
    m_color=clr;
    paint();
}
CButton::CButton(char *ptr, short clr, CRect &rect, BOOL bEn)
{
    m_bEnable=bEn;
    m_rcBtn.setRect(rect);
    if(ptr!=NULL)
    {
        m_pText=new char[strlen(ptr)+1];
        if(m_pText==NULL) throw XMemoryException();
        strcpy(m_pText, ptr);
    }
    else
        m_pText=NULL;
    m_color=clr;
    paint();
}
CButton::CButton(CButton &btn)
{
    m_bEnable=btn.m_bEnable;
    m_rcBtn.setRect(btn.m_rcBtn);
    if(btn.m_pText!=NULL)
    {
        m_pText=new char[strlen(btn.m_pText)+1];
        if(!m_pText) throw XMemoryException();
        strcpy(m_pText, btn.m_pText);
    }
    else
        m_pText=NULL;
    m_color=btn.m_color;
    paint();
}
CButton::~CButton()
{
    if(m_pText)
        delete m_pText;
}
void CButton::click()
{
    if(m_bEnable)
    {
        int x, y;
        paint(BTN_PRESSED);
        Beep(10);
        delay(100);
        Beep(5);
        paint();
    }
}
void CButton::enable(BOOL bEn)
{
    m_bEnable=bEn;
    paint();
}
void CButton::paint(BUTTONSTATE bs)
{
    int x, y;
    int shift=0;

    x=(m_rcBtn.cx-m_rcBtn.x-strlen(m_pText)*8)/2;
    y=(m_rcBtn.cy-m_rcBtn.y-16)/2;
    if(bs==BTN_RELEASED)
        DrawBox(m_rcBtn.x+1, m_rcBtn.y+1, m_rcBtn.cx-1,
            m_rcBtn.cy-1, CONVEX, TRUE);
    else
        DrawBox(m_rcBtn.x+1, m_rcBtn.y+1, m_rcBtn.cx-1,
            m_rcBtn.cy-1, CONCAVE, TRUE);

    if(bs==BTN_PRESSED)
        shift=1;
    if(m_bEnable)
        PrintString(m_rcBtn.x+x+shift, m_rcBtn.y+y+shift, m_pText, m_color);
    else
    {
        PrintString(m_rcBtn.x+x+1+shift, m_rcBtn.y+y+1+shift, m_pText, WHITE);
        PrintString(m_rcBtn.x+x+shift, m_rcBtn.y+y+shift, m_pText, DARKGRAY);
    }
}
void CButton::setFocus(BOOL bSet)
{
    if(bSet)
        _setcolor(BLACK);
    else
        _setcolor(LIGHTGRAY);
    _rectangle(_GBORDER, m_rcBtn.x, m_rcBtn.y, m_rcBtn.cx, m_rcBtn.cy);
}


CImage::CImage()
{
    m_ptr=NULL;
    m_size=0;
}
CImage::~CImage()
{
    destroy();
}
void CImage::destroy()
{
    if(m_ptr)
        delete m_ptr;
    m_ptr=NULL;
    m_size=0;
}
BOOL CImage::create(int width, int height, char *ptr, COLORS color)
{
    destroy();
    m_size=_imagesize(0,0,width-1, height-1);
    m_ptr=new char[m_size];
    
    if(m_ptr==NULL)
    {
        m_size=0;
        throw XMemoryException();
    }
    memset(m_ptr, 0, m_size);
    *((short *)m_ptr)=width;
    *((short *)m_ptr+1)=height;
    *((short *)m_ptr+2)=0x0400;

    char *mptr=m_ptr+6;
    unsigned x, y, vx, incSrc, incDst;
    vx=(m_size-6)/height;
    incSrc=0;
    incDst=0;
    for(y=0; y<height; y++)
    {
        if(color&0x08)
            memcpy(mptr+incDst, ptr+incSrc, width/8);
        if(color&0x04)
            memcpy(mptr+incDst+(vx/4), ptr+incSrc, width/8);
        if(color&0x02)
            memcpy(mptr+incDst+(vx/2), ptr+incSrc, width/8);
        if(color&0x01)
            memcpy(mptr+incDst+(vx*3/4), ptr+incSrc, width/8);
        incSrc+=width/8;
        incDst+=vx;
    }
    return TRUE;
}
BOOL CImage::dup(CImage &image)
{
    destroy();
    if(image.m_ptr)
    {
        m_ptr=new char[image.m_size];
        if(!m_ptr)
            throw XMemoryException();
        memcpy(m_ptr, image.m_ptr, m_size);
    }
    else
        m_ptr=NULL;
    m_size=image.m_size;
    return TRUE;
}
BOOL CImage::loadFromFile(char *szFilename, COLORS color)
{
    CFile file;
    char *ptr, *p;
    int n, vx;

    try
    {
        file.open(szFilename);
    }
    catch(XFileIOException e)
    {
        return FALSE;
    }

    BICHEAD bichead;
    BITMAP_HEADER bhead;
    memset(&bichead, 0, sizeof(BICHEAD));
    file.read(&bichead, sizeof(BICHEAD));
    if(bichead.id==0x04d42) // bitmap file
    {
        file.seek(0L);
        long len=file.getLength()-sizeof(BITMAP_HEADER);
        file.read(&bhead, sizeof(BITMAP_HEADER));
        ptr=new char[len];
        if(!ptr) throw XMemoryException();
        // file.seek(sizeof(BITMAP_HEADER));
        file.read(ptr, len);
        file.close();
        p=new char[len];
        if(!p) {delete ptr; throw XMemoryException();}
        vx=len/bhead.biHeight;
        for(n=0; n<bhead.biHeight; n++)
            memcpy(p+vx*(bhead.biHeight-n-1), ptr+vx*n, vx);
        delete ptr;
        create(vx*8, bhead.biHeight, p, color);
        delete p;
        return TRUE;
    }
    if((bichead.id==0x5254)&&(bichead.len_r!=0))
    {
        ptr=new char[bichead.len_r];
        if(ptr==NULL) throw XMemoryException();
        file.seek(bichead.offset_r);
        file.read(ptr, bichead.len_r);
        file.close();
        create(bichead.width, bichead.height, ptr, color);
        delete ptr;
        return TRUE;
    }
    return FALSE;
}
BOOL CImage::getImage(int x, int y, int cx, int cy)
{
    destroy();
    m_size=_imagesize(x, y, cx, cy);
    m_ptr=new char[m_size];
    if(m_ptr==NULL)
    {
        m_size=0;
        throw XMemoryException();
    }
    _getimage(x, y, cx, cy, m_ptr);
    return TRUE;
}
BOOL CImage::getImage(CRect &rect)
{
    destroy();
    m_size=_imagesize(rect.x, rect.y, rect.cx, rect.cy);
    m_ptr=new char[m_size];
    if(m_ptr==NULL)
    {
        m_size=0;
        throw XMemoryException();
    }
    _getimage(rect.x, rect.y, rect.cx, rect.cy, m_ptr);
    return TRUE;
}
void CImage::putImage(int x, int y, short mode)
{
    if(m_ptr)
        _putimage(x, y, m_ptr, mode);
}
void CImage::invert()
{
    char *ptr=m_ptr;
    for(unsigned n=6; n<m_size; n++)
        ptr[n]=~ptr[n];
}
void CImage::dump(char *szFileName)
{
    WriteDebug(szFileName,&m_size,sizeof(unsigned));
    WriteDebug(szFileName,m_ptr,m_size, TRUE);
}
CKeybrd::CKeybrd()
{
    m_nUngetKey=0;
    m_nKey=0;
}
short CKeybrd::getKey()
{
    if(m_nUngetKey)
	{
        m_nUngetKey=0;
        return m_nKey;
	}
    m_nKey=0;
    if(_bios_keybrd(_NKEYBRD_READY))
        m_nKey=scanKeybrd();
    return m_nKey;
    
}
void CKeybrd::ungetKey()
{
    m_nUngetKey=1;
}
short CKeybrd::scanKeybrd()
{
	short b=0,keycode=0;
	keycode=getch();
	if(keycode== 0){b=0x100;keycode=getch();}
	keycode=b+(keycode&0xff);
	return keycode;
}
CFile::CFile()
{
    m_hFile=NULL;
}
CFile::~CFile()
{
    close();
}

void CFile::close()
{
    if(m_hFile)
    {
        ::fclose(m_hFile);
        m_hFile=NULL;
    }
}
void CFile::flush()
{
    if(::fflush(m_hFile))
        throw XFileIOException();
}
long CFile::getLength()
{
	long len,lCurrent;

    lCurrent=tell();
    seek(0L,SEEK_END);
    len=tell();
    seek(lCurrent,SEEK_SET);
	return len;
}
BOOL CFile::isExist(char *szFilename)
{
	BOOL bExist=FALSE;

    m_hFile=::fopen(szFilename, "rb");
    if(m_hFile)
	{
		bExist=TRUE;
        ::fclose(m_hFile);
        m_hFile=NULL;
	}
	return bExist;
}
void CFile::open(char *szFilename, char *mode)
{
    if(mode==NULL)
        m_hFile=::fopen(szFilename, "rb");
    else
        m_hFile=::fopen(szFilename, mode);
    if(!m_hFile)
        throw XFileIOException();
}
void CFile::read(void *ptr, size_t size)
{
    ::fread(ptr, sizeof(char), size, m_hFile);
    if(ferror(m_hFile))
        throw XFileIOException();
}
int  CFile::readChar()
{
    int n=::fgetc(m_hFile)&0xff;
    if(ferror(m_hFile))
        throw XFileIOException();
    return n;
}
int  CFile::readInt()
{
    int n;
    n=::fgetc(m_hFile)&0xff;
    n|=(::fgetc(m_hFile)<<8)&0xff00;
    if(ferror(m_hFile))
        throw XFileIOException();
    return n;
}
long CFile::readLong()
{
    long n;
    n=readInt()&0xffffL;
    n|=((long)readInt()<<16)&0xffff0000L;
    if(ferror(m_hFile))
        throw XFileIOException();
    return n;
}
void CFile::readString(char *str, short size)
{
    ::fgets(str, size, m_hFile);
    if(ferror(m_hFile))
        throw XFileIOException();
}
void CFile::seek(long offset, int pos)
{
    if(::fseek(m_hFile, offset, pos))
        throw XFileIOException();
}
void CFile::setPos(fpos_t *poffset)
{
    if(::fsetpos(m_hFile, poffset))
        throw XFileIOException();
}
long CFile::tell()
{
    long lLen;
    lLen=::ftell(m_hFile);
    if(lLen==-1L)
        throw XFileIOException();
    return lLen;
}
void CFile::tmpfile()
{
    m_hFile=::tmpfile();
    if(m_hFile==NULL)
        throw XFileIOException();
}
void CFile::write(void *ptr, size_t size)
{
    size_t sz=::fwrite(ptr, sizeof(char), size, m_hFile);
    if(sz<size)
        throw XFileIOException();
}
void CFile::writeChar(int ch)
{
    ::fputc(ch, m_hFile);
}
void CFile::writeInt(int n)
{
    ::fputc(n&0xff, m_hFile);
    ::fputc((n>>8)&0xff, m_hFile);
}
void CFile::writeLong(long n)
{
    writeInt(n&0xffffL);
    writeInt((n>>16)&0xffffL);
}
void CFile::writeString(char *str)
{
    ::fputs(str, m_hFile);
}
CFont::CFont()
{
    m_ptr=NULL;
    width=height=0;
    m_nNum=0;
    m_lOffset=0;
}
CFont::~CFont()
{
    m_file.close();
    if(m_ptr)
        delete m_ptr;
}

void CFont::setDim(int x, int y)
{
    width=x; height=y;
}
void CFont::getDim(CPoint *ppt) const
{
    ppt->x=width;
    ppt->y=height;
}
void CFont::getDim(int *px, int *py) const
{
    *px=width;
    *py=height;
}
int CFont::loadFont(char *szFilename, short fontid)
{
    FONT_HEAD fh;
    FONT_CHUNCK fc;

    BITMAP_HEADER bhead;
    try {
    m_file.open(szFilename); }
    catch(XFileIOException e)
    {
        return 0;
    }
    m_file.read(&fh, sizeof(FONT_HEAD));
    if(fh.id==0x4d42)
    {
        m_file.seek(0L);
        m_file.read(&bhead, sizeof(BITMAP_HEADER));
        width=(bhead.biWidth+31)/32*32;
        height=bhead.biHeight;
        m_lOffset=0;
        type=3;
    }
    else if((fh.id==0x5446) || (fh.version==0x100))
    {
        m_lOffset=sizeof(FONT_HEAD);
        for(;;)
        {
            m_file.seek(m_lOffset);
            m_file.read(&fc, sizeof(FONT_CHUNCK));
            if(fc.id==-1) return 0;
            if(fc.id==fontid)
            {
                m_nNum=fc.num;
                width=fc.width;
                height=fc.height;
                m_lOffset+=sizeof(FONT_CHUNCK);
                type=2;
                break;
            }
            m_lOffset+=sizeof(FONT_CHUNCK)+
                (long)fc.num*(long)fc.width*(long)fc.height/8;
        }
    }
    else
    {
        m_lOffset=0;
        width=0;
        height=0;
        type=1;
    }
    return type;
}

int CFont::loadFontIntoMem(char *szFilename, short fontid)
{
    FONT_HEAD fh;
    FONT_CHUNCK fc;
    BITMAP_HEADER bhead;

    if(m_ptr)
        delete m_ptr;
    try {
    m_file.open(szFilename); }
    catch(XFileIOException e)
    {
        return 0;
    }
    long len=m_file.getLength();
    m_file.read(&fh, sizeof(FONT_HEAD));
    if(fh.id==0x4d42)
    {
        m_file.seek(0L);
        m_file.read(&bhead, sizeof(BITMAP_HEADER));
        width=(bhead.biWidth+31)/32*32;
        height=bhead.biHeight;
        m_lOffset=0;
        type=3;
    }
    else if((fh.id==0x5446) || (fh.version==0x100))
    {
        m_lOffset=sizeof(FONT_HEAD);
        for(;;)
        {
            m_file.seek(m_lOffset);
            m_file.read(&fc, sizeof(FONT_CHUNCK));
            if(fc.id==-1) return 0;
            if(fc.id==fontid)
            {
                m_nNum=fc.num;
                width=fc.width;
                height=fc.height;
                m_lOffset+=sizeof(FONT_CHUNCK);
                len=(long)fc.num*(long)fc.width*(long)fc.height/8;
                type=2;
                break;
            }
            m_lOffset+=sizeof(FONT_CHUNCK)+
                (long)fc.num*(long)fc.width*(long)fc.height/8;
        }
    }
    else
    {
        m_lOffset=0;
        width=0;
        height=0;
        type=1;
    }
    m_ptr=new char[len];
    if(!m_ptr)
    {
       m_file.close();
       throw XMemoryException();
    }
    m_file.read(m_ptr, len);
    m_file.close();
    return type;
}

void CFont::writeAt(int x, int y, long index, short color, BOOL bTrans)
{
    int offset, sy, sx, vx, size;
    CImage imgMask;

    size=width*height/8;
    char *ptr=new char[size];
    if(!ptr) throw XMemoryException();

    if(m_ptr)
    {
        if(type==3) // mono color bitmap
        {
            vx=width>>3;
            for(sy=0; sy<height; sy++)
                memcpy(ptr+(height-sy-1)*vx, m_ptr+sy*vx, vx);
        }
        else
            memcpy(ptr, m_ptr+index*size, size);
        if(bTrans)
        {
            imgMask.create(width, height, ptr, WHITE);
            imgMask.invert();
        }
        m_imgFont.create(width, height, ptr, color);
    }
    else
    {
        switch(type)
        {
            case 1:
                offset=0; break;
            case 2:
                offset=m_lOffset; break;
            case 3:
                offset=sizeof(BITMAP_HEADER); break;
            default:
                offset=0; break;
        }
        m_file.seek(index*size+offset);
        m_file.read(ptr, size);
        if(type==3)
        {
            vx=width>>3;
            char *p=new char[size];
            if(!p) throw XMemoryException();
            memcpy(p, ptr, size);
            for(sy=0; sy<height; sy++)
                memcpy(ptr+(height-sy-1)*vx, p+sy*vx, vx);
            delete p;
        }
        if(bTrans)
        {
            imgMask.create(width, height, ptr, WHITE);
            imgMask.invert();
        }
        m_imgFont.create(width, height, ptr, color);
    }
    if(bTrans)
    {
        imgMask.putImage(x, y, _GAND);
        m_imgFont.putImage(x, y, _GOR);
    }
    else
        m_imgFont.putImage(x, y);
    m_imgFont.destroy();
    delete ptr;
}

//////////// Static /////////////////
CStatic::CStatic(short sx, short sy, char const *stext, short slen,
            BOXSHAPE sshape, COLORS scolor,
            COLORS sbkcolor)
{
    m_bShow=FALSE;
	x=sx; y=sy;
	len=round(slen,0,80);
	if(len)
	{
		text=new char [len];
        if(!text) throw XMemoryException();
		if(stext)
			strncpy(text,stext,len);
		else
			text[0]=0;
	}
	else
		text=NULL;
	shape=sshape;
	color=scolor;
	bkcolor=sbkcolor;
    show();
}
CStatic::CStatic(CStatic const &stat)
{
    m_bShow=stat.m_bShow;
	x=stat.x;
	y=stat.y;
	len=stat.len;
	shape=stat.shape;
	color=stat.color;
	bkcolor=stat.bkcolor;
	if(len)
	{
		text= new char[len];
        if(!text) throw XMemoryException();
		strcpy(text,stat.text);
	}
	else
		text=NULL;
    show();
}
CStatic::~CStatic()
{
    if(m_bShow)
        hide();
	if(text)
		delete text;
}

void CStatic::show()
{
    m_bShow=TRUE;
    clear();
	if(len)
		PrintString(x+2,y+2,text,color);
}
void CStatic::hide()
{
    m_bShow=FALSE;
	short oldcolor=_getcolor();
	_setcolor(LIGHTGRAY);
	_rectangle(_GFILLINTERIOR,x,y,x+len*8+4,y+20);
	_setcolor(oldcolor);
}
void CStatic::setText(char const *stext,short n)
{
	if(stext)
    {
    	if(n==-1)
			strncpy(text,stext,len);
        else
        	strncpy(text,stext,min(len,n));
    }
	else
		text[0]=0;
    show();
}
void CStatic::setText(int n, int radix)
{
	char tmp[80];
    itoa(n,tmp,radix);
	strncpy(text,tmp,len);
    show();
}
void CStatic::setColor(short scolor, short sbkcolor)
{
	color=scolor;
	bkcolor=sbkcolor;
    show();
}
void CStatic::setShape(BOXSHAPE bs)
{
	shape=bs;
    show();
}
void CStatic::move(short sx,short sy)
{
	x=sx;
	y=sy;
    hide();
    show();
}
void CStatic::clear()
{
	short oldcolor=_getcolor();
	_setcolor(bkcolor);
	_rectangle(_GFILLINTERIOR,x,y,x+len*8+4,y+20);
	DrawBox(x,y,x+len*8+4,y+20,shape);
	_setcolor(oldcolor);
}
BOOL CStatic::isBlank()
{
	short n;
	for(n=0;n<strlen(text);n++)
    {
    	if( (text[n]!=KEY_TAB)&&(text[n]!=KEY_RETURN)&&(text[n]!=KEY_SPACE) )
        	break;
    }
    return n==strlen(text)?TRUE:FALSE;

}

/////////// Edit ////////////

CEdit::CEdit(short sx, short sy, char const *stext, short slen,
			BOXSHAPE sshape, short scolor,
			short sbkcolor)
{
    m_bShow=TRUE;
    m_nX=sx; m_nY=sy;
    m_nLen=round(slen,0,80);
    if(m_nLen)
	{
        m_pText=new char [m_nLen];
        if(!m_pText) throw XMemoryException();
		if(stext)
            strncpy(m_pText,stext,m_nLen);
		else
            m_pText[0]=0;
	}
	else
        m_pText=NULL;
    m_bs=sshape;
    m_nColor=scolor;
    m_nBkcolor=sbkcolor;
    show();
}
CEdit::CEdit(CEdit const &stat)
{
    m_bShow=stat.m_bShow;
    m_nX=stat.m_nX;
    m_nY=stat.m_nY;
    m_nLen=stat.m_nLen;
    m_bs=stat.m_bs;
    m_nColor=stat.m_nColor;
    m_nBkcolor=stat.m_nBkcolor;
    if(m_nLen)
	{
        m_pText= new char[m_nLen];
        if(!m_pText) throw XMemoryException();
        strcpy(m_pText,stat.m_pText);
	}
	else
        m_pText=NULL;
    show();
}
CEdit::~CEdit()
{
    if(m_bShow)
        setVisible(FALSE);
    if(m_pText)
        delete m_pText;
}

void CEdit::show()
{
    if(m_bShow)
    {
        clear();
        if(m_nLen)
            PrintString(m_nX+2,m_nY+2,m_pText,m_nColor);
    }
}
void CEdit::setVisible(BOOL bVis)
{
    COLORS oldcolor;
	if(bVis)
    {
        if(m_bShow)
        	return ; // nothing should change
        else
        {
            m_bShow=TRUE;
            show();
        }
    }
    else
    {
        if(!m_bShow)
        	return ;
        else
        {
            m_bShow=FALSE;
			oldcolor=_getcolor();
			_setcolor(LIGHTGRAY);
            _rectangle(_GFILLINTERIOR,m_nX,m_nY,m_nX+m_nLen*8+4,m_nY+20);
			_setcolor(oldcolor);
        }
    }
}
void CEdit::setText(char const *stext,short n)
{
	if(stext)
    {
    	if(n==-1)
            strncpy(m_pText,stext,m_nLen);
        else
            strncpy(m_pText,stext,min(m_nLen,n));
    }
	else
        m_pText[0]=0;
    show();
}
void CEdit::setText(int n, int radix)
{
	char tmp[80];
    itoa(n,tmp,radix);
    strncpy(m_pText,tmp,m_nLen);
    show();
}

BOOL CEdit::usrIsChin(short key)
{
    if(key<0)
		return TRUE;
	return FALSE;
}
BOOL CEdit::usrIsPrint(short key)
{
	if(key&0xff00)
    	return FALSE;
    if(isprint(key))
    	return TRUE;
    return FALSE;
}
void CEdit::clearChar(short x, short y, COLORS color)
{
    COLORS oldcolor=_getcolor();
	_setcolor(color);
	_rectangle(_GFILLINTERIOR,x,y,x+8,y+16);
	_setcolor(oldcolor);
}
short CEdit::getText(char *stext)
{
	if(stext)
        strcpy(stext,m_pText);
    return strlen(m_pText);
}
short CEdit::input(char *stext)
{
    short nPos=strlen(m_pText), key;
    char *tmptext=new char [m_nLen+1];
    if(!tmptext) throw XMemoryException();
    strcpy(tmptext,m_pText);
    PrintString(m_nX+2+nPos*8,m_nY+2,"_",WHITE);
    CKeybrd keybrd;

	for(;;)
	{
        key=keybrd.getKey();
        if(usrIsPrint(key))
		{
            if(nPos+1>m_nLen-1)
				Beep();
			else
			{
				tmptext[nPos]=key;
				tmptext[nPos+1]=0;
                clearChar(m_nX+2+nPos*8,m_nY+2,m_nBkcolor);
                PrintString(m_nX+2+nPos*8,m_nY+2,tmptext+nPos,m_nColor);
				nPos++;
                PrintString(m_nX+2+nPos*8,m_nY+2,"_",WHITE);
			}
		}
        if(usrIsChin(key))
		{
            if(nPos+2>m_nLen-1)
				Beep();
			else
			{
				tmptext[nPos]=(ushort(key)>>8)&0xff;
				tmptext[nPos+1]=ushort(key)&0xff;
				tmptext[nPos+2]=0;
                clearChar(m_nX+2+nPos*8,m_nY+2,m_nBkcolor);
                clearChar(m_nX+2+(nPos+1)*8,m_nY+2,m_nBkcolor);
                PrintString(m_nX+2+nPos*8,m_nY+2,tmptext+nPos,m_nColor);
				nPos+=2;
                PrintString(m_nX+2+nPos*8,m_nY+2,"_",WHITE);
			}
		}
		switch(key)
		{
			case KEY_DELETE:
			case KEY_BACKSPACE:
				if(nPos-1>=0)
				{
                    clearChar(m_nX+2+nPos*8,m_nY+2,m_nBkcolor);
					nPos--;
                    clearChar(m_nX+2+nPos*8,m_nY+2,m_nBkcolor);
                    PrintString(m_nX+2+nPos*8,m_nY+2,"_",WHITE);
					tmptext[nPos]=0;
				}
				else
					Beep();
				break;
			case KEY_RETURN:	// return
                clearChar(m_nX+2+nPos*8,m_nY+2,m_nBkcolor);
                strcpy(m_pText,tmptext);
				strcpy(stext,tmptext);
                show();
				delete tmptext;
				return key;
			case KEY_ESC:
                strcpy(stext,m_pText);
                show();
				delete tmptext;
				return key;
		}
	}
}

void CEdit::setColor(short scolor, short sbkcolor)
{
    m_nColor=scolor;
    if(sbkcolor!=-1)
        m_nBkcolor=sbkcolor;
    if(sbkcolor==-1)
    {
        if(m_nLen)
            PrintString(m_nX+2,m_nY+2,m_pText,m_nColor);
    }
    else
        show();
}
void CEdit::setBkColor(short sbkcolor)
{
    m_nBkcolor=sbkcolor;
    show();
}
void CEdit::move(short sx,short sy)
{
    setVisible(FALSE);
    m_nX=sx;
    m_nY=sy;
    show();
}
void CEdit::clear()
{
    COLORS oldcolor=_getcolor();
    _setcolor(m_nBkcolor);
    _rectangle(_GFILLINTERIOR,m_nX,m_nY,m_nX+m_nLen*8+4,m_nY+20);
    DrawBox(m_nX,m_nY,m_nX+m_nLen*8+4,m_nY+20,m_bs);
	_setcolor(oldcolor);
}
BOOL CEdit::isBlank()
{
	short n;
    for(n=0;n<strlen(m_pText);n++)
    {
        if( (m_pText[n]!=KEY_TAB)&&(m_pText[n]!=KEY_RETURN)&&
            (m_pText[n]!=KEY_SPACE) )
        	break;
    }
    return n==strlen(m_pText)?TRUE:FALSE;
}


// private members
/*
        short m_nWinRound;
        short m_nMaxRound;
        short m_nMaxPoint;
        TYPE m_nType;

        short m_nGameID;
        char *m_szGameName;

        short m_sPtA[MAXROUND];
        short m_sPtB[MAXROUND];
        // BOOL m_nsRdOver[MAXROUND];
        short m_nCurRound; // <=MAXROUND
        short m_nInService; // 0: none, 1: A, 2: B

        BOOL m_bChangeService;
        BOOL m_bCountRound;
        short m_nInc1, m_nInc2, m_nInc3, m_nDec1;

        BOOL m_bRoundOver;
        BOOL m_bMatchOver;
*/
// public members
CCounter::CCounter()
{
    m_nWinRound=0;
    m_nMaxRound=0;
    m_nMaxPoint=0;
    m_nType=NIL;

    m_nGameID=0;
    m_szGameName=new char[1];

    if(!m_szGameName) throw XMemoryException();

    int i;
    for(i=0; i<MAXROUND; i++)
        m_sPtA[i]=0;
    for(i=0; i<MAXROUND; i++)
        m_sPtB[i]=0;
    m_nCurRound=0; // <=MAXRound
    m_nInService=0; // 0: none, 1: A, 2: B


    m_bChangeService=0;
    m_bCountRound=0;
    m_nInc1=m_nInc2=m_nInc3=m_nDec1=0;

    m_bRoundOver=FALSE;
    m_bMatchOver=FALSE;
}
CCounter::~CCounter()
{
    if(m_szGameName)
        delete m_szGameName;
}

short CCounter::loadScript(char *szFilename, short nGameID)
{
    CFile file;
    try {file.open(szFilename);}
    catch(XFileIOException e)
    {    return -1;  }

    int len=file.getLength();
    char *buf=new char[len+1];
    if(buf==NULL)
        throw XMemoryException();

    file.read(buf, len);
    buf[len]='\0';
    file.close();

    CToken tok;
    // fasm: A finite state mashine, 
    int fasm=0, lineno=1;
    short *pItem=NULL;

    tok.init(buf, 0, TRUE);
    delete buf;

    CFile debug;
    debug.open("FASM","wt");
    static char tmp[256], tt[1];

    for(;fasm!=5;)
    {
        try
        {
            tok.getNext();
        }
        catch(XTokenException e)
        {
            e.dump();
        }
        sprintf(tmp, "FASM=%d \tTYPE=%s \tNAME=%s \t\tVAL=%ld\n",
            fasm, szTokenName[(int)tok.m_eType], tok.m_szName, tok.m_lValue);
        debug.writeString(tmp);
        if(tok.m_eType==CToken::COMMENT)
            continue;
        if(tok.m_eType==CToken::EOL)
            lineno++;
        if(tok.m_eType==CToken::TEOF)
            break;
        switch(fasm)
        {
            case 0:
                if(tok.m_eType==CToken::IDNUMBER) // '#'
                    fasm=1;
                break;
            case 1:
                if(tok.m_eType==CToken::SPACE)
                    break;
                if((tok.m_eType==CToken::NUMBER) && (tok.m_lValue==nGameID))
                {
                    m_nGameID=nGameID;
                    fasm=2;
                }
                else if(tok.m_eType==CToken::NUMBER)
                    fasm=0;
                else
                    return lineno; // error
                break;
            case 2:
                if(tok.m_eType==CToken::SPACE) break;
                if(tok.m_eType==CToken::EOL) break;
                if(tok.m_eType==CToken::IDNUMBER) // '#'
                {
                    fasm=5; break;
                }
                if(tok.m_eType==CToken::VAR)
                {
                    if(!strcmp(tok.m_szName,"NAME"))
                        pItem=(short *)m_szGameName;
                    else if(!strcmp(tok.m_szName,"MR"))
                        pItem=&m_nMaxRound;
                    else if(!strcmp(tok.m_szName,"CR"))
                        pItem=(short *)&m_bCountRound;
                    else if(!strcmp(tok.m_szName,"WR"))
                        pItem=&m_nWinRound;
                    else if(!strcmp(tok.m_szName,"MPT"))
                        pItem=&m_nMaxPoint;
                    else if(!strcmp(tok.m_szName,"TYPE"))
                        pItem=(short *)&m_nType;
                    else if(!strcmp(tok.m_szName,"INC1"))
                        pItem=&m_nInc1;
                    else if(!strcmp(tok.m_szName,"INC2"))
                        pItem=&m_nInc2;
                    else if(!strcmp(tok.m_szName,"INC3"))
                        pItem=&m_nInc3;
                    else if(!strcmp(tok.m_szName,"DEC1"))
                        pItem=&m_nDec1;
                    else if(!strcmp(tok.m_szName,"CS"))
                        pItem=(short *)(BOOL *)&m_bChangeService;
                    else
                        return lineno;
                    if(pItem)
                        fasm=3;
                }
                else
                    return lineno;
                break;
            case 3:
                if(tok.m_eType==CToken::SPACE) break;
                if(tok.m_eType==CToken::EQUAL)
                    fasm=4;
                else
                    return lineno;
                break;
            case 4:
                if(tok.m_eType==CToken::SPACE) break;
                if(tok.m_eType==CToken::VAR)
                {
                    if(m_szGameName)
                        delete m_szGameName;
                    m_szGameName=new char[strlen(tok.m_szName)+1];
                    if(!m_szGameName)
                        throw XMemoryException();
                    strcpy(m_szGameName, tok.m_szName);
                    if(pItem)
                        pItem=NULL;
                    fasm=2;
                }
                else if(tok.m_eType==CToken::NUMBER)
                {
                    if(pItem)
                    {
                        *pItem=tok.m_lValue;
                        fasm=2;
                        pItem=NULL;
                    }
                }
                else
                    return lineno;
                break;
        }
    }
    if(fasm!=5) return lineno;

    sprintf(tmp, "FASM=%d \tTYPE=%s \tNAME=%s \t\tVAL=%ld\n",
        fasm, szTokenName[(int)tok.m_eType], tok.m_szName, tok.m_lValue);
    debug.writeString(tmp);
    debug.close();

    return 0;
}

short CCounter::getWinRound()
{
    return m_nWinRound;
}
short CCounter::getMaxRound()
{
    return m_nMaxRound;
}
short CCounter::getMaxPoint()
{
    return m_nMaxPoint;
}
CCounter::TYPE CCounter::getType()
{
    return m_nType;
}

short CCounter::getGameID()
{
    return m_nGameID;
}
void CCounter::getGameName(char *szGameName)
{
    if(szGameName!=NULL)
        strcpy(szGameName, m_szGameName);
}

short CCounter::getScoreA(short nRound)
{
    if(nRound==-1) nRound=m_nCurRound;

    if(m_bCountRound)
        return m_sPtA[nRound];
    int nAWin=0, n;
    for(n=0; n<m_nMaxRound; n++)
        nAWin+=m_sPtA[n];
    return nAWin;
}
short CCounter::getScoreB(short nRound)
{
    if(nRound==-1) nRound=m_nCurRound;

    if(m_bCountRound)
        return m_sPtB[nRound];
    int nBWin=0, n;
    for(n=0; n<m_nMaxRound; n++)
        nBWin+=m_sPtB[n];
    return nBWin;
}
short CCounter::getWinRoundA()
{
    if(!m_bCountRound) return 0;
    int nAWin=0, n;
    for(n=0; n<m_nMaxRound; n++)
        if(whoWinRound(n)==1) nAWin++;
    return nAWin;
}
short CCounter::getWinRoundB()
{
    if(!m_bCountRound) return 0;
    int nBWin=0, n;
    for(n=0; n<m_nMaxRound; n++)
        if(whoWinRound(n)==2) nBWin++;
    return nBWin;
}
BOOL CCounter::isRoundOver()
{
    return m_bRoundOver;
}
BOOL CCounter::isMatchOver()
{
    return m_bMatchOver;
}

// return 0, deuce not over yet; 1: A win; 2: B win.
short CCounter::whoWinRound(short nRound)
{
    if(nRound==-1)
        nRound=m_nCurRound;
    if((m_nType==UNLIMPOINT) && m_bRoundOver)
        return m_sPtA[nRound]==m_sPtB[nRound]?0:
            (m_sPtA[nRound]>m_sPtB[nRound]?1:2);
    if(m_nType==UNLIMTIME)
    {
        if(abs(m_sPtA[nRound]-m_sPtB[nRound])<2)
            return 0;
        if(m_sPtA[nRound]>m_sPtB[nRound])
        {
            if(m_sPtA[nRound]>=m_nMaxPoint)
                return 1;
            else
                return 0;
        }
        else
        {
            if(m_sPtB[nRound]>=m_nMaxPoint)
                return 2;
            else
                return 0;
        }
    }
    return 0;
}

// return 0, deuce not over yet; 1: A win; 2: B win.
short CCounter::whoWinMatch()
{
    short nAWin=0, nBWin=0;
    if(m_nType==UNLIMTIME)
    {
        for(int n=0; n<m_nMaxRound; n++)
        {
            switch(whoWinRound(n))
            {
                case 1: nAWin++; break;
                case 2: nBWin++; break;
            }
        }
        if(nAWin>m_nWinRound)
            return 1;
        else if(nBWin>m_nWinRound)
            return 2;
        return 0;
    }
    // else
    if(m_bMatchOver)
    {
        for(int n=0; n<m_nMaxRound; n++)
        {
            nAWin+=m_sPtA[n];
            nBWin+=m_sPtB[n];
        }
        return nAWin==nBWin?0:(nAWin>nBWin?1:2);
    }

    return 0;
}
void CCounter::inc1A()
{
    if(m_bChangeService && (m_nInService!=1)) // not my turn to inc
        return ;
    if(m_bCountRound)
        m_sPtA[m_nCurRound]+=m_nInc1;
}
void CCounter::inc2A()
{
    if(m_bChangeService && (m_nInService!=1)) // not my turn to inc
        return ;
    if(m_bCountRound)
        m_sPtA[m_nCurRound]+=m_nInc2;
}
void CCounter::inc3A()
{
    if(m_bChangeService && (m_nInService!=1)) // not my turn to inc
        return ;
    if(m_bCountRound)
        m_sPtA[m_nCurRound]+=m_nInc2;
}
void CCounter::dec1A()
{
    if(m_bChangeService && (m_nInService!=1)) // not my turn to inc
        return ;
    if(m_bCountRound)
        m_sPtA[m_nCurRound]+=m_nDec1;
}

void CCounter::inc1B()
{
    if(m_bChangeService && (m_nInService!=2)) // not my turn to inc
        return ;
    if(m_bCountRound)
        m_sPtB[m_nCurRound]+=m_nInc1;
}
void CCounter::inc2B()
{
    if(m_bChangeService && (m_nInService!=2)) // not my turn to inc
        return ;
    if(m_bCountRound)
        m_sPtB[m_nCurRound]+=m_nInc2;
}
void CCounter::inc3B()
{
    if(m_bChangeService && (m_nInService!=2)) // not my turn to inc
        return ;
    if(m_bCountRound)
        m_sPtB[m_nCurRound]+=m_nInc2;
}
void CCounter::dec1B()
{
    if(m_bChangeService && (m_nInService!=2)) // not my turn to inc
        return ;
    if(m_bCountRound)
        m_sPtB[m_nCurRound]+=m_nDec1;
}
void CCounter::setService(short nServe)
{
    m_nInService=nServe;
}
void CCounter::setRoundOver()
{
    m_bRoundOver=TRUE;
}
void CCounter::setMatchOver()
{
    m_bMatchOver=TRUE;
}
void CCounter::dump(char *name)
{
    char tmp[128];
    CFile debug;
    debug.open(name,"wt");
    sprintf(tmp, "m_nWinRound=%d\n", m_nWinRound);
    debug.writeString(tmp);
    sprintf(tmp, "m_nMaxRound=%d\n", m_nMaxRound);
    debug.writeString(tmp);
    sprintf(tmp, "m_nMaxPoint=%d\n", m_nMaxPoint);
    debug.writeString(tmp);
    sprintf(tmp, "m_nType=%d\n", m_nType);
    debug.writeString(tmp);
    sprintf(tmp, "m_nGameID=%d\n", m_nGameID);
    debug.writeString(tmp);
    sprintf(tmp, "m_szGameName=%s\n", m_szGameName==NULL?"#":m_szGameName);
    debug.writeString(tmp);
    sprintf(tmp, "m_nWinRound=%d\n", m_nWinRound);
    debug.writeString(tmp);
    sprintf(tmp, "m_nWinRound=%d\n", m_nWinRound);
    debug.writeString(tmp);
    sprintf(tmp, "m_sPtA=%d, %d, %d, %d, %d\n", m_sPtA[0], m_sPtA[1], m_sPtA[2], m_sPtA[3],m_sPtA[4]);
    debug.writeString(tmp);
    sprintf(tmp, "m_sPtB=%d, %d, %d, %d, %d\n", m_sPtB[0], m_sPtB[1], m_sPtB[2], m_sPtB[3],m_sPtB[4]);
    debug.writeString(tmp);
    sprintf(tmp, "m_nCurRound=%d\n", m_nCurRound);
    debug.writeString(tmp);
    sprintf(tmp, "m_nInService=%d\n", m_nInService);
    debug.writeString(tmp);
    sprintf(tmp, "m_bChangeService=%d\n", (int)m_bChangeService);
    debug.writeString(tmp);
    sprintf(tmp, "m_nInService=%d\n", m_nInService);
    debug.writeString(tmp);
    sprintf(tmp, "m_bCountRound=%d\n", (int)m_bCountRound);
    debug.writeString(tmp);
    sprintf(tmp, "m_nInc1=%d\n", m_nInc1);
    debug.writeString(tmp);
    sprintf(tmp, "m_nInc2=%d\n", m_nInc2);
    debug.writeString(tmp);
    sprintf(tmp, "m_nInc3=%d\n", m_nInc3);
    debug.writeString(tmp);
    sprintf(tmp, "m_nDec1=%d\n", m_nDec1);
    debug.writeString(tmp);
    sprintf(tmp, "m_bRoundOver=%d\n", m_bRoundOver);
    debug.writeString(tmp);
    sprintf(tmp, "m_bMatchOver=%d\n", m_bMatchOver);
    debug.writeString(tmp);

    debug.close();
}

short CCounter::get900(short val)
{
    return (val-val/1000*1000)/100;
}
short CCounter::get90(short val)
{
    return (val-val/100*100)/10;
}
short CCounter::get9(short val)
{
    return val-val/10*10;
}

/// protected members
