#if !defined(IMAGE_HPP_)
#define IMAGE_HPP_

#include <user.h>

#include "misc.hpp"
#include "file.hpp"

typedef struct
{
    unsigned short id; // 'TR' 0x5254
    short width;
    short height;
    unsigned short color;
    unsigned short version;
	long offset_r;
	long len_r;
	long offset_g;
	long len_g;
	long offset_b;
	long len_b;
	unsigned char reserved[14];
} BICHEAD, *NPBICHEAD; // 48 bytes structure


typedef struct tagRGBQUAD
{
    byte    rgbBlue;
    byte    rgbGreen;
    byte    rgbRed;
    byte    rgbReserved;
} RGBQUAD;

typedef struct tagBITMAPINFOHEADER
{
    short    bfType;
    long   bfSize;
    short    bfReserved1;
    short    bfReserved2;
    long   bfOffBits;

    long   biSize;
    long    biWidth;
    long    biHeight;
    short    biPlanes;
    short    biBitCount;
    long   biCompression;
    long   biSizeImage;
    long    biXPelsPerMeter;
    long    biYPelsPerMeter;
    long   biClrUsed;
    long   biClrImportant;
    RGBQUAD bmiColor[2];
} BITMAP_HEADER;


class CImage
{
    private:
        char *m_ptr;
        unsigned m_size;
    public:
        CImage();
        ~CImage();
        BOOL create(int x, int y, char *ptr, COLORS color=WHITE);
        BOOL dup(CImage &);
        BOOL loadFromFile(char *szFilename, COLORS color=WHITE);
        void destroy();

        BOOL getImage(int x, int y, int cx, int cy);
        BOOL getImage(CRect &rect);
        void putImage(int x, int y, short mode=_GPSET);

        void invert(void);
        void dump(char *szFilename); // for debug purpose
};

#endif
