#if !defined(TOKEN_HPP)
#define TOKEN_HPP

#include <user.h>

#define MAXSTRING	80

#define CASE_SENSITIVE   0
#define CASE_INSENSITIVE 1

class CToken
{
    public:
        enum TYPE {NIL, VAR, STRING, NUMBER, SYMBOL, EQUAL, IDNUMBER,
            EOL, TEOF, SPACE, ERROR, COMMENT};
    private:
        char *m_pStart;
        char *m_pCur;
        unsigned m_nLen;
        short m_nLast;
        BOOL m_bDuplicated;
        int m_nLineno;
    public:
        TYPE m_eType;
        char m_szName[MAXSTRING];
        long m_lValue;
    public:
        CToken();
        ~CToken();
        BOOL init(char *p, unsigned m_nLen=0,
            BOOL dup=FALSE, short nCase=CASE_INSENSITIVE);
        void getNext();
        void unget();
        int getLineno() const {return m_nLineno;}

    protected:
        BOOL isSymbol(char ch);
        BOOL isVarFirst(char ch);
        BOOL isVarNext(char ch);
};

#endif
